<%
   Class ForeignKeyInformation
      '************** MEMBER VARIABLES *********************
      Private strColumnName
      Private strPKTableName
      Private strPKColumnName
      '*****************************************************

      '****************** GET PROPERTIES *******************
      Public Property Get ColumnName()
        ColumnName = strColumnName
      End Property

      Public Property Get PrimaryKeyTable()
        PrimaryKeyTable = strPKTableName
      End Property

      Public Property Get PrimaryKeyColumn()
        PrimaryKeyColumn = strPKColumnName
      End Property
      '*****************************************************

      '****************** LET PROPERTIES *******************
      Public Property Let ColumnName(str)
        strColumnName = str
      End Property

      Public Property Let PrimaryKeyTable(strPKTable)
        strPKTableName = strPKTable
      End Property

      Public Property Let PrimaryKeyColumn(strPKColumn)
        strPKColumnName = strPKColumn
      End Property
      '*****************************************************
   End Class


   Class ForeignKeys
      '************** MEMBER VARIABLES *********************
      Private objFKDict
      '*****************************************************

      '******************* EVENT HANDLERS ******************
      Private Sub Class_Initialize()
        Set objFKDict = Server.CreateObject("Scripting.Dictionary")
      End Sub

      Private Sub Class_Terminate()
        Set objFKDict = Nothing        'Clean up...
      End Sub
      '*****************************************************

      
      '********************** METHODS **********************
      Public Sub PopulateForeignKeys(strTableName, objConn)
        'This sub is responsible for populating the objFKDict
        'dictionary object with the foreign keys from the table
        'strTableName.  objConn is expected to be an opened connection
        'to the proper database

        Dim objRS     'Open up the column schema
        Set objRS = objConn.OpenSchema(adSchemaForeignKeys, _
                       Array(Empty, Empty, Empty, Empty, Empty, strTableName))

        'Add a ForeignKeyInformation object instance for each column that
        'exists within the table specified by strTableName
        Dim objFK
        Do While Not objRS.EOF
           Set objFK = New ForeignKeyInformation

           objFK.ColumnName = objRS("FK_COLUMN_NAME")
           objFK.PrimaryKeyTable = objRS("PK_TABLE_NAME")
           objFK.PrimaryKeyColumn = objRS("PK_COLUMN_NAME")

           objFKDict.Add objFK.ColumnName, objFK

           Set objFK = Nothing
           objRS.MoveNext
        Loop

        'Clean up...
        objRS.Close
        Set objRS = Nothing         
      End Sub


      Public Function GetForeignKeyInformation(strFKName)
         'Returns a specific FK's information... that is, return a
         'reference to an instance of a ForeignKeyInformation object
         If objFKDict.Exists(strFKName) then
           Set GetForeignKeyInformation = objFKDict(strFKName)
         Else
           Set GetForeignKeyInformation = Nothing
         End If
      End Function

      Public Function ForeignKeyExists(strFKName)
         ForeignKeyExists = objFKDict.Exists(strFKName)
      End Function
      '*****************************************************


      '****************** GET PROPERTIES *******************
      Public Property Get Count()
         Count = objFKDict.Count
      End Property
      '*****************************************************
   End Class
%>